import java.awt.Graphics;
import java.awt.Image;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.sql.*;
import java.io.*;
import java.util.*;

import oracle.jdbc.driver.*;

public class DisplayImage extends java.applet.Applet
implements ActionListener
{
Image theImage;
String showImage;

Button execute_button;
TextField theStatus = new TextField(64);
Font theFixedFont = new Font(Courier,Font.PLAIN,12);

public void init( )
{
try
{
Class.forName (oracle.jdbc.driver.OracleDriver);
}

catch (ClassNotFoundException c)
{
handleError(c);
}
try
{
Connection conn =
DriverManager.getConnection (
jdbc:oracle:oci8:TEST, graphics_dba, graphics1);

Statement stmt = conn.createStatement ();

ResultSet rset = stmt.executeQuery (
select graphic_blob from internal_graphics where
graphic_id=6);
if (rset.next ())
{
OracleBlob blob = ((OracleResultSet)rset).getBlob (1);
dumpBlob(conn,blob);
}
}

catch (SQLException sql)
{
handleError(sql);
}

catch (IOException e)
{
handleError(e);
}
catch (Exception s)
{
handleError(s);
}
{
this.setLayout (new BorderLayout ());
Panel p = new Panel ();
p.setLayout (new FlowLayout (FlowLayout.LEFT));
execute_button = new Button (Show Image);
execute_button.addActionListener(this);
p.add (execute_button);
this.add (North, p);
add(theStatus, South);
theStatus.setEditable(false);
theImage = getImage(getCodeBase(),theImage.gif);
}
}


public void actionPerformed(ActionEvent event)
{
Object source = event.getSource();
if (source == execute_button)
{
showImage = true;
repaint();
}
}


public void paint(Graphics theGraphic)
{
if (showImage != null) {
int iwidth = theImage.getWidth(this);
int iheight = theImage.getHeight(this);
int xpos = 375;
theGraphic.drawImage(theImage, xpos, 10, iwidth, iheight, this);}
String showImage = null;
}


public void handleError(Throwable t)
{
theStatus.setText(Error:  + t.getMessage( ));
t.printStackTrace( );
}


static void dumpBlob (Connection conn, OracleBlob blob)
throws Exception
{
OracleCallableStatement cstmt1 =
(OracleCallableStatement)
conn.prepareCall (begin ? := dbms_lob.getLength (?); end;);
OracleCallableStatement cstmt2 =
(OracleCallableStatement)
conn.prepareCall (begin dbms_lob.read (?, ?, ?, ?); end;);
cstmt1.registerOutParameter (1, Types.NUMERIC);
cstmt1.setBlob (2, blob);
cstmt1.execute ();

long length = cstmt1.getLong (1);
long i=0;
int chunk=100;

FileOutputStream file = new FileOutputStream (theImage.gif);
while (i < length)
{
cstmt2.setBlob (1, blob);
cstmt2.setLong (2, chunk);
cstmt2.registerOutParameter (2, Types.NUMERIC);
cstmt2.setLong (3, i+1);
cstmt2.registerOutParameter (4, Types.VARBINARY);
cstmt2.execute ();
long read_this_time = cstmt2.getLong (2);
byte [] bytes_this_time = cstmt2.getBytes (4);
{

file.write (bytes_this_time);
i += read_this_time;
/* System.out.print (Read  + i +  bytes of  + length + \n);*/
if ((i + read_this_time)>length) chunk = (int) (length-i);
}
}
file.close();
cstmt1.close ();
cstmt2.close ();
}
}