import java.applet.*;
import java.sql.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
public class DBATempSelect extends Applet
implements ActionListener
{
Frame theFrame = new Frame();
Frame logFrame = new Frame();
Panel mainPanel = new Panel();
Panel loginPanel = new Panel();
Panel buttonPanel = new Panel();
TextField theStatus = new TextField(64);
TextArea theResult = new TextArea(15,60);
static TextField theSource = new TextField(32);
Button doConnect = new Button("Connect");
Button qryButton = new Button ("Do Query");
Button stopdamnit = new Button ("Quit");
Panel[] thePanel = new Panel[4];
static TextField theUser = new TextField(32);
static TextField thePassword = new TextField(32);
Button btnOK = new Button("OK");
Button btnCancel = new Button("Cancel");
Button btnQuit = new Button("Quit");
boolean statusOK = false;
String theURL;
Statement theStatement;
ResultSet rs;
Connection theConnection;
public void init( )
{
theFrame.setTitle("Simple Query");
theFrame.add("Center",mainPanel);
mainPanel.setLayout(new BorderLayout());
mainPanel.add("North",theSource);
mainPanel.add("South",theStatus);
theResult.setFont(new Font("Courier", Font.PLAIN, 12));
mainPanel.add("Center", theResult);
mainPanel.add("North",buttonPanel);
buttonPanel.setLayout(new GridLayout(1,3));
buttonPanel.add("North", doConnect);
doConnect.addActionListener(this);
buttonPanel.add("North", qryButton);
qryButton.addActionListener(this);
buttonPanel.add("North", stopdamnit);
stopdamnit.addActionListener(this);
logFrame.setTitle("Login Frame");
setFont(new Font("Courier", Font.PLAIN, 12));
loginPanel.setLayout(new GridLayout(4, 1));
for (int i = 0; i < 3; i++)
{
thePanel[i] = new Panel( );
thePanel[i].setLayout(new BorderLayout( ));
}
thePanel[0].add("West", new Label("URL: ",Label.RIGHT));
thePanel[0].add("Center",theSource);
loginPanel.add(thePanel[0]);
thePanel[1].add("West", new Label("User: ",Label.RIGHT));
thePanel[1].add("Center", theUser);
loginPanel.add(thePanel[1]);
thePanel[2].add("West", new Label("Password: ",Label.RIGHT));
thePanel[2].add("Center", thePassword);
loginPanel.add(thePanel[2]);
thePanel[3] = new Panel( );
thePanel[3].setLayout(new FlowLayout( ));
thePanel[3].add(btnOK);
thePanel[3].add(btnCancel);
thePanel[3].add(btnQuit);
loginPanel.add(thePanel[3]);
btnOK.addActionListener(this);
btnCancel.addActionListener(this);
btnQuit.addActionListener(this);
logFrame.setLayout(new BorderLayout());
logFrame.add("Center",loginPanel);
logFrame.validate();
logFrame.pack();
logFrame.setVisible(false);
theFrame.pack();
theFrame.setVisible(true);
}
public void actionPerformed(ActionEvent event)
{
Object source = event.getSource( );
theStatus.setText("Status: OK");
if (source == doConnect)
{
logFrame.setVisible(true);
theSource.requestFocus();
openConnection();
}
if (source == qryButton) doQuery();
if (source == btnOK)
{
logFrame.setVisible(false);
statusOK=true;
}
if (source == btnQuit)
{
blankText();
logFrame.setVisible(false);
statusOK=false;
}
if (source == stopdamnit) System.exit(0);
}
public boolean openConnection()
{
try
{
theStatus.setText("Status: OK");
if (statusOK==true)
{
String driver_class = "oracle.jdbc.driver.OracleDriver";
Class.forName (driver_class);
if (theConnection != null) theConnection.close( );
/*System.out.println(getURL() + ":" + getUser() + ":" +
getPassword());*/
theConnection =
DriverManager.getConnection("jdbc:oracle:thin:@" + getURL( ),
getUser( ),
getPassword( ));
logFrame.setVisible(false);
blankText();
}
return true;
}
catch (NullPointerException n)
{
theStatus.setText("Error:" + n);
}
catch (Exception t)
{
theStatus.setText("Status: Login Dialog " + t);
}
return false;
}
public void doQuery()
{
/*System.out.println("Got to doQuery");*/
try
{
theResult.setText("");
/*System.out.println("First Try at connection");*/
theStatement = theConnection.createStatement();
rs = theStatement.executeQuery("SELECT rpad(NAME,40)||': '||
to_char(VALUE,'999,999,999.999')" +
"FROM DBA_TEMP order by rep_order");
while (rs.next())
{
theResult.append(rs.getString(1)+"\n");
}
}
catch(SQLException sqlex)
{
theStatus.setText("Error: " + sqlex.getMessage( ));
}
}

public void requestClose()
{
setVisible(false);
try
{
if (theConnection != null) theConnection.close();
}
catch(SQLException sql) { ; }
}
public boolean getStatus( ) { return statusOK; };
public String getURL( ) { return theSource.getText( ); }
public String getUser( ) { return theUser.getText( ); }
public String getPassword( ) { return thePassword.getText( ); }
public void blankText ()
{
theSource.setText("");
theUser.setText("");
thePassword.setText("");
}
}
